const request = require("request");
const fs = require("fs");
const Promise = require("promise");

var Captcha = function(key, captcha_response){

  this.key = key;

  this.verify = () => {

    return new Promise(

      (resolve, reject) => {

        if(!captcha_response)
          return reject({error: 'no_captcha'})

        request.post(
          {
            url:'https://www.google.com/recaptcha/api/siteverify',
            form: {secret: key, response: captcha_response}
          },
             (err, response, body) => {

               body = JSON.parse(body);
               if(err) return reject([{error: 'captcha_err'}, 400]);

               if(body.success == false)
                  return reject([{error: 'bad_captcha'}, 400]);

               return resolve(body)

          })

      }

    )

  }

}

module.exports = Captcha;
